unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    LTitel: TLabel;
    LFrage: TLabel;
    RGAntwort: TRadioGroup;
    LAuswertung: TLabel;
    BBOk: TBitBtn;
    procedure BBOkClick(Sender: TObject);
    procedure RGAntwortClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure frage_stellen(nr:integer);
    procedure beenden;

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  nr,
  richtig,
  treffer : integer;
  rest: set of 0..3;

implementation

{$R *.DFM}


procedure TForm1.frage_stellen(nr:integer);

begin
rest:=rest-[nr];            // eine Frage weniger
RGAntwort.ItemIndex:=-1;    // keine Auswahl
RGAntwort.enabled:=true;    // Auswahl freigeben
LAuswertung.Caption:='';    // Auswertung lschen
case nr of
     0:  begin
         Lfrage.caption:='Text der 1. Frage';
         RGAntwort.items[0]:='a1';
         RGAntwort.items[1]:='a2';
         RGAntwort.items[2]:='a3';
         RGAntwort.items[3]:='a4';
         richtig:=2;
         end;
    1:  begin
         LFrage.caption:='Text der 2. Frage';
         RGAntwort.items[0]:='b1';
         RGAntwort.items[1]:='b2';
         RGAntwort.items[2]:='b3';
         RGAntwort.items[3]:='b4';
         richtig:=3;
         end;
    2:  begin
         LFrage.caption:='Text der 3. Frage';
         RGAntwort.items[0]:='c1';
         RGAntwort.items[1]:='c2';
         RGAntwort.items[2]:='c3';
         RGAntwort.items[3]:='c4';
         richtig:=1;
         end;
    3:  begin
         LFrage.caption:='Text der 4. Frage';
         RGAntwort.items[0]:='d1';
         RGAntwort.items[1]:='d2';
         RGAntwort.items[2]:='d3';
         RGAntwort.items[3]:='d4';
         richtig:=0;
         end;
    end;
end;

procedure TForm1.beenden;
begin
if treffer>2 then
   LAuswertung.color:=cllime
 else
   LAuswertung.color:=clfuchsia;
LAuswertung.Caption:='Du hast ' + inttostr(treffer) +
                     ' von 4 Fragen richtig beantwortet';
BBOk.Kind:=bkclose;  //Kind legt Bitmap-Schaltflche fest
end;

procedure TForm1.BBOkClick(Sender: TObject);
begin
if rest=[] then beenden
 else
   begin
   repeat
     nr:=random(4);
   until nr in rest;
   frage_stellen(nr);
   end;
end;

procedure TForm1.RGAntwortClick(Sender: TObject);
begin
if RGAntwort.ItemIndex=richtig then
   begin
   treffer:=treffer+1;
   LAuswertung.Caption:='Prima - Deine Antwort ist richtig';
   end
 else
   LAuswertung.Caption:='Schade - Deine Antwort ist leider falsch'+#13+
                        'Richtig wre: ' + RGAntwort.items[richtig];
RGAntwort.Enabled:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
LAuswertung.Caption:='';
randomize;
rest:=[0,1,2,3];
treffer:=0;
nr:=random(4);
frage_stellen(nr);
end;

end.
