unit Unit1;

// Rechentrainer 2
// MVC Implementierung nach K. Becker

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PTitel: TPanel;
    GBAuswahl: TGroupBox;
    BAddition: TButton;
    BSubtraktion: TButton;
    BMultiplikation: TButton;
    BDivision: TButton;
    BErgebnis: TButton;
    GBAufgabe: TGroupBox;
    LZahl1: TLabel;
    LOperator: TLabel;
    LGleich: TLabel;
    LZahl2: TLabel;
    LErgebnis: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BRechenzeichenClick(Sender: TObject);
    procedure BErgebnisClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Datenmodell

var
  Rechenzeichen: char;
  Zahl1, Zahl2, Ergebnis: integer;

procedure AufgabeErzeugen;
begin
Zahl1 := random(11);
Zahl2 := random(11);
end;

procedure ErgebnisBerechnen;
begin
case Rechenzeichen of
  '+': Ergebnis := Zahl1 + Zahl2;
  '-': Ergebnis := Zahl1 - Zahl2;
  '*': Ergebnis := Zahl1 * Zahl2;
  ':': Ergebnis := Zahl1 div Zahl2;
end;
end;

// Ereignisbehandlungsmethoden

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
end;

procedure TForm1.BRechenzeichenClick(Sender: TObject);
begin

// Aktualisierung der Modelldaten
if Sender = BAddition then Rechenzeichen := '+';
if Sender = BSubtraktion then Rechenzeichen := '-';
if Sender = BMultiplikation then Rechenzeichen := '*';
if Sender = BDivision then Rechenzeichen := ':';
// kurz: Rechenzeichen := TButton(Sender).Caption[1];

// Aufruf der Verarbeitungsoperationen
AufgabeErzeugen;
ErgebnisBerechnen;

// Aktualisierung der Anzeige  
LZahl1.Caption := IntToStr(Zahl1);
LOperator.Caption := Rechenzeichen;
LZahl2.Caption := IntToStr(Zahl2);
LGleich.Visible := true;
LErgebnis.Caption := IntToStr(Ergebnis);
LErgebnis.Visible := false;
end;

procedure TForm1.BErgebnisClick(Sender: TObject);
begin
LErgebnis.Visible := true;
end;

end.
