unit Unit1;

// Rechentrainer 4
// MVC Implementierung nach K. Becker

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PTitel: TPanel;
    GBAuswahl: TGroupBox;
    BAddition: TButton;
    BSubtraktion: TButton;
    BMultiplikation: TButton;
    BDivision: TButton;
    GBAufgabe: TGroupBox;
    LZahl1: TLabel;
    LOperator: TLabel;
    LGleich: TLabel;
    LZahl2: TLabel;
    EErgebnis: TEdit;
    GBewertung: TGroupBox;
    LBewertung: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BRechenzeichenClick(Sender: TObject);
    procedure EErgebnisChange(Sender: TObject);
    procedure EErgebnisKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Datenmodell

var
  Rechenzeichen: char;
  Zahl1, Zahl2, Ergebnis: integer;
  Vorschlag: integer;

procedure AufgabeErzeugen;
begin
Zahl1 := random(11);
Zahl2 := random(11);
end;

procedure ErgebnisBerechnen;
begin
case Rechenzeichen of
  '+': Ergebnis := Zahl1 + Zahl2;
  '-': Ergebnis := Zahl1 - Zahl2;
  '*': Ergebnis := Zahl1 * Zahl2;
  ':': Ergebnis := Zahl1 div Zahl2;
end;
end;

// Ereignisbehandlungsmethoden

procedure TForm1.FormCreate(Sender: TObject);
begin
randomize;
end;

procedure TForm1.BRechenzeichenClick(Sender: TObject);
begin
// Aktualisierung der Modelldaten
if Sender = BAddition then Rechenzeichen := '+';
if Sender = BSubtraktion then Rechenzeichen := '-';
if Sender = BMultiplikation then Rechenzeichen := '*';
if Sender = BDivision then Rechenzeichen := ':';
// Aufruf der Verarbeitungsoperationen
AufgabeErzeugen;
ErgebnisBerechnen;
// Aktualisierung der Anzeige
LBewertung.Visible:=false;
LZahl1.Caption := IntToStr(Zahl1);
LOperator.Caption := Rechenzeichen;
LZahl2.Caption := IntToStr(Zahl2);
LGleich.Visible := true;
EErgebnis.Visible:=true;
EErgebnis.SetFocus;
end;

procedure TForm1.EErgebnisChange(Sender: TObject);
begin
LBewertung.Visible:=false;
if EErgebnis.Text<>'' then
   Vorschlag := StrToInt(EErgebnis.Text);
if Vorschlag = Ergebnis then
  begin
  LBewertung.Font.Color:= clgreen;
  LBewertung.Caption := 'Prima - Richtig !'
  end
else
  begin
  LBewertung.Font.Color:= clred;
  LBewertung.Caption := 'Leider - Falsch !';
  end;
end;

procedure TForm1.EErgebnisKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=vk_return then LBewertung.Visible:=true;
end;

end.
