unit Formular;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, uDeklaration, uAuswahlsort, uBubblesort, uEinfuegesort;

type
  TForm1 = class(TForm)
    LTitel: TLabel;
    LEingabe: TLabel;
    LAusgabe: TLabel;
    BAuswahlsort: TButton;
    BNeueEingabe: TButton;
    LBAusgabe: TListBox;
    MEingabe: TMemo;
    LHinweis: TLabel;
    BEinfuegen: TButton;
    BBubble: TButton;
    procedure SortierenClick(Sender: TObject);
    procedure BNeueEingabeClick(Sender: TObject);
    procedure MEingabeChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;


var
  Form1: TForm1;
  feld: tfeld;      // tfeld ist in der uDeklaration deklariert

implementation

{$R *.DFM}

procedure TForm1.SortierenClick(Sender: TObject);

var anzahl, nr:integer;

begin
LBAusgabe.clear;
anzahl:=MEingabe.lines.count;       //Anzahl der Wrter
if anzahl > max then anzahl:=max;   //Maximum aus uDefinition
for nr:=1 to anzahl do feld[nr]:=MEingabe.lines.strings[nr-1];

if sender =BAuswahlsort then
   begin
   LBAusgabe.Font.Color:=clblack;
   a_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;
if sender =BEinfuegen then
   begin
   LBAusgabe.Font.Color:=clblue;
   e_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;
if sender =BBubble then
   begin
   LBAusgabe.Font.Color:=clred;
   b_sortieren(feld,anzahl);
   LTitel.Caption:=verfahren;
   end;

for nr:=1 to anzahl do LBAusgabe.items.add(feld[nr]);
end;

procedure TForm1.BNeueEingabeClick(Sender: TObject);
begin
MEingabe.clear;
LBAusgabe.clear;
end;

procedure TForm1.MEingabeChange(Sender: TObject);
begin
LBAusgabe.clear;
if MEingabe.lines.count>max then
   begin
   LHinweis.visible:=true;
   LHinweis.caption:='Nur die ersten '+IntToStr(max)+' Wrter werden sortiert!'
   end
 else
   LHinweis.visible:=false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
LTitel.Caption:='Sortieren';
end;

end.

