unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    LUeberschrift: TLabel;
    GEingabe: TGroupBox;
    EGroesse: TEdit;
    LGroesse: TLabel;
    EGewicht: TEdit;
    LGewicht: TLabel;
    GAusgabe: TGroupBox;
    EBMI: TEdit;
    LBMI: TLabel;
    BBerechnen: TButton;
    Bzuruecksetzen: TButton;
    LBemerkung: TLabel;
    procedure BBerechnenClick(Sender: TObject);
    procedure BzuruecksetzenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
Groesse: real;
Gewicht: real;
bmi: real;
Rat: string;

procedure berechnen;
begin
bmi:=Gewicht/sqr(Groesse);
end;

procedure Auswertung;
begin
if bmi < 16 then
   rat:= 'Starkes Untergewicht';
if (bmi >= 16) and (bmi < 18.5) then
   rat:= 'leichtes Untergewicht';
if (bmi >= 18.5) and (bmi < 25) then
   rat:= 'Normalgewicht';
if (bmi >= 25) and (bmi < 30) then
   rat:= 'leichtes bergewicht';
if bmi > 30 then
   rat:= 'Starkes bergewicht';
end;

procedure TForm1.BBerechnenClick(Sender: TObject);
begin
Groesse:=strtofloat(egroesse.text);
Gewicht:=strtofloat(egewicht.text);
berechnen;
auswertung;
EBMI.text:= Floattostrf(bmi, fffixed, 8, 1);
LBemerkung.caption:= rat;
end;

procedure TForm1.BzuruecksetzenClick(Sender: TObject);
begin
Egroesse.text:='';
Egewicht.text:= '';
Ebmi.text:= '';
LBemerkung.caption:='';
end;

end.
