unit Verzeichn;         // Telefonverzeichnis 2 mit Men

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Menus;

type
  TForm1 = class(TForm)
    PTitel: TPanel;
    LName: TLabel;
    LVorname: TLabel;
    LTelefonnummer: TLabel;
    EName: TEdit;
    EVorname: TEdit;
    ETelNum: TEdit;
    BHinzu: TButton;
    BAendern: TButton;
    BLoeschen: TButton;
    BAllesLoeschen: TButton;
    LBVerzeichnis: TListBox;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Laden1: TMenuItem;
    Speichern1: TMenuItem;
    Panel1: TPanel;
    procedure BHinzuClick(Sender: TObject);
    procedure BSpeichernClick(Sender: TObject);
    procedure BLadenClick(Sender: TObject);
    procedure LBVerzeichnisClick(Sender: TObject);
    procedure BAendernClick(Sender: TObject);
    procedure BLoeschenClick(Sender: TObject);
    procedure BAllesLoeschenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

procedure TForm1.BHinzuClick(Sender: TObject);
begin
if (EName.text>'')then
   begin
   LBVerzeichnis.Items.Add(EName.text+','+EVorname.text
                                     +','+ETelnum.text);
   EName.text:='';
   EVorname.text:='';
   ETelNum.text:='';
   LBVerzeichnis.ItemIndex:=-1;
   end;
end;

procedure TForm1.BSpeichernClick(Sender: TObject);
begin
if SaveDialog1.execute=true then
   LBVerzeichnis.Items.SaveToFile(SaveDialog1.filename)
end;

procedure TForm1.BLadenClick(Sender: TObject);
begin
if OpenDialog1.execute=true then
   LBVerzeichnis.Items.LoadFromFile(OpenDialog1.filename)
end;

procedure TForm1.LBVerzeichnisClick(Sender: TObject);

var eintrag:string;
    komma:integer;

begin
eintrag:=LBVerzeichnis.Items[LBVerzeichnis.ItemIndex];
komma:=pos(',',eintrag);
EName.text:=copy(eintrag,1,komma-1);
delete(eintrag,1,komma);
komma:=pos(',',eintrag);
EVorname.text:=copy(eintrag,1,komma-1);
delete(eintrag,1,komma);
ETelNum.text:=eintrag;
end;

procedure TForm1.BAendernClick(Sender: TObject);
begin
if LBVerzeichnis.ItemIndex>-1 then
   LBVerzeichnis.Items[LBVerzeichnis.ItemIndex]:=
      (EName.text+','+EVorname.text+','+ETelnum.text);

end;

procedure TForm1.BLoeschenClick(Sender: TObject);
begin
if LBVerzeichnis.ItemIndex>-1 then
   LBVerzeichnis.Items.Delete(LBVerzeichnis.ItemIndex);
   EName.text:='';
   EVorname.text:='';
   ETelNum.text:='';
end;

procedure TForm1.BAllesLoeschenClick(Sender: TObject);
begin
If LBVerzeichnis.Items.Count>0 then
   If MessageDlg('Wirklich alles lschen?',mtWarning,
                 [mbYes,mbNo],0)=mrYes
      then LBVerzeichnis.Items.Clear;

end;

end.
