unit Unit1;

// Programm zur Simualion des Weltbevlkerungswachstums nach K. Becker

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    LUeberschrift: TLabel;
    BWeiter: TButton;
    EJahr: TEdit;
    EAnzahl: TEdit;
    LJahr: TLabel;
    LAnzahl: TLabel;
    BInit: TButton;
    procedure BInitClick(Sender: TObject);
    procedure BWeiterClick(Sender: TObject);
    procedure BZurueckClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Datenmodell
const
  p = 1.3; 
var
  Jahr   : integer;
  Anzahl : real;

// Operationen zur Aktualisierung des Datenmodells
procedure initPopulation;
begin
Jahr   := 1999;
Anzahl := 6.0;
end;

procedure naechstePopulation;
begin
Jahr   := Jahr + 1;
Anzahl := Anzahl + p/100*Anzahl;
end;

procedure PopulationZurueck;
begin
Jahr := Jahr-1;
Anzahl := Anzahl/(1+p/100);
if Jahr<1999 then InitPopulation;
end;

// Ereignisbehandlungsmethoden
procedure TForm1.BInitClick(Sender: TObject);
begin
initPopulation;
EJahr.Text   := IntToStr(Jahr);
EAnzahl.Text := FloatToStrF(Anzahl,ffnumber,8,2)+' Mrd';
end;

procedure TForm1.BWeiterClick(Sender: TObject);
begin
naechstePopulation;
EJahr.Text   := IntToStr(Jahr);
EAnzahl.Text := FloatToStrF(Anzahl,ffnumber,8,2)+' Mrd';
end;

procedure TForm1.BZurueckClick(Sender: TObject);
begin
PopulationZurueck;
EJahr.Text   := IntToStr(Jahr);
EAnzahl.Text := FloatToStrF(Anzahl,ffnumber,8,2)+' Mrd';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
initpopulation;
EJahr.Text   := IntToStr(Jahr);
EAnzahl.Text := FloatToStrF(Anzahl,ffnumber,8,2)+' Mrd';
end;

end.
