unit Unit1;

// logistisches Wachstum

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    LUeberschrift: TLabel;
    BWeiter: TButton;
    EJahr: TEdit;
    EAnzahl: TEdit;
    LJahr: TLabel;
    LAnzahl: TLabel;
    BInit: TButton;
    BZurueck: TButton;
    B10zurueck: TButton;
    B10weiter: TButton;
    procedure BInitClick(Sender: TObject);
    procedure BWeiterClick(Sender: TObject);
    procedure BZurueckClick(Sender: TObject);
    procedure B10zurueckClick(Sender: TObject);
    procedure B10weiterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// Datenmodell
var
  Jahr   : integer;
  Anzahl : real;

// Operationen zur Aktualisierung des Datenmodells (model)
procedure initPopulation;
begin
Jahr   := 1999;
Anzahl := 6.0;
end;

procedure naechstepopulation;
begin
Jahr := Jahr + 1;
Anzahl := Anzahl+0.0027*Anzahl*(11-Anzahl);
end;

procedure populationzurueck;
begin
Jahr := Jahr - 1;
Anzahl := (1+0.0027*11)/(2*0.0027)-sqrt((1+0.0027*11)/(2*0.0027)*(1+0.0027*11)/(2*0.0027)-(Anzahl/0.0027));
if Jahr<1999 then InitPopulation;
end;

procedure Population10vor;
var i:integer;
begin
for i:=1 to 10 do
  naechstePopulation;
end;

procedure Population10zurueck;
var i:integer;
begin
for i:=1 to 10 do
  PopulationZurueck;
end;

// Operation zur Aktualisierung der Anzeige (view)
procedure Anzeige;
begin
Form1.EJahr.Text   := IntToStr(Jahr);
Form1.EAnzahl.Text := FloatToStrF(Anzahl,ffnumber,8,2)+ ' Mrd';
end;

// Ereignisbehandlungsmethoden (controller)
procedure TForm1.BInitClick(Sender: TObject);
begin
initPopulation;
Anzeige;
end;

procedure TForm1.BWeiterClick(Sender: TObject);
begin
naechstePopulation;
Anzeige;
end;

procedure TForm1.BZurueckClick(Sender: TObject);
begin
PopulationZurueck;
Anzeige;
end;

procedure TForm1.B10zurueckClick(Sender: TObject);
begin
Population10zurueck;
Anzeige;
end;

procedure TForm1.B10weiterClick(Sender: TObject);
begin
Population10Vor;
Anzeige;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
initpopulation;
Anzeige;
end;

end.
