unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    LTitel: TLabel;
    LAufforderung: TLabel;
    LInfo: TLabel;
    BStart: TButton;
    EStartzahl: TEdit;
    MAusgabe: TMemo;

    procedure EStartzahlChange(Sender: TObject);
    procedure BStartClick(Sender: TObject);
    procedure EStartzahlKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  startzahl:integer;

implementation

{$R *.DFM}

procedure TForm1.EStartzahlChange(Sender: TObject);
begin
LInfo.visible:=false;
MAusgabe.lines.Clear;
end;

// Modell

procedure naechste_zahl(var startzahl:integer);
begin
if startzahl mod 2 =0 then startzahl:=startzahl div 2
                      else startzahl:=startzahl+1;
end;

procedure TForm1.BStartClick(Sender: TObject);
begin
if EStartzahl.Text>'' then startzahl:=StrToInt(EStartzahl.Text)
                      else startzahl:=0;
if startzahl>0 then
  begin
  MAusgabe.lines.Clear;
  MAusgabe.lines.Add(IntToStr(startzahl));
  repeat
    naechste_zahl(startzahl);
    MAusgabe.lines.Add(IntToStr(startzahl));
  until startzahl=1;
  LInfo.visible:=true;
  LInfo.caption:='Die Raupe hat'
                  +#13+IntToStr(MAusgabe.lines.Count)
                  +#13+'Glieder';
  end;
end;

// Return bei Eingabe

procedure TForm1.EStartzahlKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=VK_Return then BStart.Click
end;

end.
